using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;

namespace UserModule_BG_4K_VP44
{
    public class UserModuleClass_BG_4K_VP44 : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        
        Crestron.Logos.SplusObjects.BufferInput RX_MATRIX;
        Crestron.Logos.SplusObjects.AnalogInput CLEAR_PRESET_MODE;
        Crestron.Logos.SplusObjects.AnalogInput STORE_PRESET_MODE;
        Crestron.Logos.SplusObjects.AnalogInput RECALL_PRESET_MODE;
        Crestron.Logos.SplusObjects.AnalogInput CLEAR_PRESET_SCENE;
        Crestron.Logos.SplusObjects.AnalogInput STORE_PRESET_SCENE;
        Crestron.Logos.SplusObjects.AnalogInput RECALL_PRESET_SCENE;
        Crestron.Logos.SplusObjects.AnalogInput VIDEO_FEED_ON;
        Crestron.Logos.SplusObjects.AnalogInput VIDEO_FEED_OFF;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_HDMI_ON;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_HDMI_OFF;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_SOURCE_OUTPUT1;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_SOURCE_OUTPUT2;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_SOURCE_OUTPUT3;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_SOURCE_OUTPUT4;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_SOURCE_OUTPUT_ALL;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_EXTRACTION_OFF;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_EXTRACTION_ON;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_EXTRACTION_SOURCE_OUTPUT1;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_EXTRACTION_SOURCE_OUTPUT2;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_EXTRACTION_SOURCE_OUTPUT3;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_EXTRACTION_SOURCE_OUTPUT4;
        Crestron.Logos.SplusObjects.AnalogInput AUDIO_EXTRACTION_SOURCE_OUTPUT_ALL;
        Crestron.Logos.SplusObjects.AnalogInput VIDEO_RESOLUTION_OUTPUT1;
        Crestron.Logos.SplusObjects.AnalogInput VIDEO_RESOLUTION_OUTPUT2;
        Crestron.Logos.SplusObjects.AnalogInput VIDEO_RESOLUTION_OUTPUT3;
        Crestron.Logos.SplusObjects.AnalogInput VIDEO_RESOLUTION_OUTPUT4;
        Crestron.Logos.SplusObjects.AnalogInput VIDEO_RESOLUTION_OUTPUT_ALL;
        Crestron.Logos.SplusObjects.DigitalInput SEND_GAPX_OUTPUT1;
        Crestron.Logos.SplusObjects.DigitalInput SEND_GAPX_OUTPUT2;
        Crestron.Logos.SplusObjects.DigitalInput SEND_GAPX_OUTPUT3;
        Crestron.Logos.SplusObjects.DigitalInput SEND_GAPX_OUTPUT4;
        Crestron.Logos.SplusObjects.DigitalInput SEND_GAPX_OUTPUT_ALL;
        Crestron.Logos.SplusObjects.DigitalInput SEND_GAPY_OUTPUT1;
        Crestron.Logos.SplusObjects.DigitalInput SEND_GAPY_OUTPUT2;
        Crestron.Logos.SplusObjects.DigitalInput SEND_GAPY_OUTPUT3;
        Crestron.Logos.SplusObjects.DigitalInput SEND_GAPY_OUTPUT4;
        Crestron.Logos.SplusObjects.DigitalInput SEND_GAPY_OUTPUT_ALL;
        Crestron.Logos.SplusObjects.AnalogInput GAPX_OUTPUT1;
        Crestron.Logos.SplusObjects.AnalogInput GAPX_OUTPUT2;
        Crestron.Logos.SplusObjects.AnalogInput GAPX_OUTPUT3;
        Crestron.Logos.SplusObjects.AnalogInput GAPX_OUTPUT4;
        Crestron.Logos.SplusObjects.AnalogInput GAPX_OUTPUT_ALL;
        Crestron.Logos.SplusObjects.AnalogInput GAPY_OUTPUT1;
        Crestron.Logos.SplusObjects.AnalogInput GAPY_OUTPUT2;
        Crestron.Logos.SplusObjects.AnalogInput GAPY_OUTPUT3;
        Crestron.Logos.SplusObjects.AnalogInput GAPY_OUTPUT4;
        Crestron.Logos.SplusObjects.AnalogInput GAPY_OUTPUT_ALL;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> OUTPUT;
        Crestron.Logos.SplusObjects.StringOutput TX_MATRIX;
        Crestron.Logos.SplusObjects.StringOutput TO_SIO;
        object RX_MATRIX_OnChange_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                CrestronString MESSAGE;
                MESSAGE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 65534, this );
                
                CrestronString INFO;
                INFO  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 65534, this );
                
                ushort P1 = 0;
                ushort P2 = 0;
                ushort P3 = 0;
                ushort P4 = 0;
                
                
                __context__.SourceCodeLine = 175;
                MESSAGE  .UpdateValue ( MESSAGE + RX_MATRIX  ) ; 
                __context__.SourceCodeLine = 176;
                Functions.Delay (  (int) ( 100 ) ) ; 
                __context__.SourceCodeLine = 177;
                Functions.Delay (  (int) ( 100 ) ) ; 
                __context__.SourceCodeLine = 178;
                P1 = (ushort) ( Functions.Find( "Output" , MESSAGE ) ) ; 
                __context__.SourceCodeLine = 179;
                INFO  .UpdateValue ( Functions.Mid ( MESSAGE ,  (int) ( P1 ) ,  (int) ( 100 ) )  ) ; 
                __context__.SourceCodeLine = 181;
                TO_SIO  .UpdateValue ( INFO  ) ; 
                __context__.SourceCodeLine = 183;
                Functions.ClearBuffer ( RX_MATRIX ) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    object CLEAR_PRESET_MODE_OnChange_1 ( Object __EventInfo__ )
    
        { 
        Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
        try
        {
            SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
            CrestronString STRINGOUT1;
            STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
            
            
            __context__.SourceCodeLine = 195;
            MakeString ( STRINGOUT1 , "{0:d}", (ushort)CLEAR_PRESET_MODE  .UshortValue) ; 
            __context__.SourceCodeLine = 196;
            TX_MATRIX  .UpdateValue ( "#preset mode" + STRINGOUT1 + " exe=0"  ) ; 
            
            
        }
        catch(Exception e) { ObjectCatchHandler(e); }
        finally { ObjectFinallyHandler( __SignalEventArg__ ); }
        return this;
        
    }
    
object STORE_PRESET_MODE_OnChange_2 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
        
        
        __context__.SourceCodeLine = 206;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)STORE_PRESET_MODE  .UshortValue) ; 
        __context__.SourceCodeLine = 207;
        TX_MATRIX  .UpdateValue ( "#preset mode" + STRINGOUT1 + " exe=1"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object RECALL_PRESET_MODE_OnChange_3 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
        
        
        __context__.SourceCodeLine = 216;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)RECALL_PRESET_MODE  .UshortValue) ; 
        __context__.SourceCodeLine = 217;
        TX_MATRIX  .UpdateValue ( "#preset mode" + STRINGOUT1 + " exe=2"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object CLEAR_PRESET_SCENE_OnChange_4 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
        
        
        __context__.SourceCodeLine = 226;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)CLEAR_PRESET_SCENE  .UshortValue) ; 
        __context__.SourceCodeLine = 227;
        TX_MATRIX  .UpdateValue ( "#preset scene" + STRINGOUT1 + " exe=0"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object STORE_PRESET_SCENE_OnChange_5 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
        
        
        __context__.SourceCodeLine = 238;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)STORE_PRESET_SCENE  .UshortValue) ; 
        __context__.SourceCodeLine = 239;
        TX_MATRIX  .UpdateValue ( "#preset scene" + STRINGOUT1 + " exe=1"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object RECALL_PRESET_SCENE_OnChange_6 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
        
        
        __context__.SourceCodeLine = 250;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)RECALL_PRESET_SCENE  .UshortValue) ; 
        __context__.SourceCodeLine = 251;
        TX_MATRIX  .UpdateValue ( "#preset scene" + STRINGOUT1 + " exe=2"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object VIDEO_FEED_OFF_OnChange_7 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 260;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)VIDEO_FEED_OFF  .UshortValue) ; 
        __context__.SourceCodeLine = 261;
        TX_MATRIX  .UpdateValue ( "#video_d out" + STRINGOUT1 + " onoff=0"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object VIDEO_FEED_ON_OnChange_8 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 271;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)VIDEO_FEED_ON  .UshortValue) ; 
        __context__.SourceCodeLine = 272;
        TX_MATRIX  .UpdateValue ( "#video_d out" + STRINGOUT1 + " onoff=1"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_HDMI_OFF_OnChange_9 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 288;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_HDMI_OFF  .UshortValue) ; 
        __context__.SourceCodeLine = 289;
        TX_MATRIX  .UpdateValue ( "#audio_d out" + STRINGOUT1 + " hdmi_onoff=0"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_HDMI_ON_OnChange_10 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 300;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_HDMI_ON  .UshortValue) ; 
        __context__.SourceCodeLine = 301;
        TX_MATRIX  .UpdateValue ( "#audio_d out" + STRINGOUT1 + " hdmi_onoff=1"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_EXTRACTION_OFF_OnChange_11 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 315;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_EXTRACTION_OFF  .UshortValue) ; 
        __context__.SourceCodeLine = 316;
        TX_MATRIX  .UpdateValue ( "#audio_d out" + STRINGOUT1 + " dec_onoff=0"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_EXTRACTION_ON_OnChange_12 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 327;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_EXTRACTION_ON  .UshortValue) ; 
        __context__.SourceCodeLine = 328;
        TX_MATRIX  .UpdateValue ( "#audio_d out" + STRINGOUT1 + " dec_onoff=1"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTPUT_OnChange_13 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort LASTNUM = 0;
        
        CrestronString SINPUT;
        CrestronString SOUTPUT;
        SINPUT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        SOUTPUT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 337;
        LASTNUM = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 338;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (LASTNUM == 1))  ) ) 
            {
            __context__.SourceCodeLine = 338;
            SOUTPUT  .UpdateValue ( "0"  ) ; 
            }
        
        else 
            {
            __context__.SourceCodeLine = 339;
            SOUTPUT  .UpdateValue ( Functions.ItoA (  (int) ( (LASTNUM - 1) ) )  ) ; 
            }
        
        __context__.SourceCodeLine = 340;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( OUTPUT[ LASTNUM ] .UshortValue < 1 ))  ) ) 
            {
            __context__.SourceCodeLine = 340;
            SINPUT  .UpdateValue ( "0" + Functions.ItoA (  (int) ( OUTPUT[ LASTNUM ] .UshortValue ) )  ) ; 
            }
        
        else 
            {
            __context__.SourceCodeLine = 341;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT[ LASTNUM ] .UshortValue == 9))  ) ) 
                {
                __context__.SourceCodeLine = 341;
                SINPUT  .UpdateValue ( "0"  ) ; 
                }
            
            else 
                {
                __context__.SourceCodeLine = 342;
                SINPUT  .UpdateValue ( Functions.ItoA (  (int) ( OUTPUT[ LASTNUM ] .UshortValue ) )  ) ; 
                }
            
            }
        
        __context__.SourceCodeLine = 343;
        MakeString ( TX_MATRIX , "#video_d out{0} source={1}", SOUTPUT , SINPUT ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_SOURCE_OUTPUT1_OnChange_14 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 355;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_SOURCE_OUTPUT1  .UshortValue) ; 
        __context__.SourceCodeLine = 356;
        TX_MATRIX  .UpdateValue ( "#audio_d out0 hdmi_source=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_SOURCE_OUTPUT2_OnChange_15 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 367;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_SOURCE_OUTPUT2  .UshortValue) ; 
        __context__.SourceCodeLine = 368;
        TX_MATRIX  .UpdateValue ( "#audio_d out1 hdmi_source=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_SOURCE_OUTPUT3_OnChange_16 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 378;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_SOURCE_OUTPUT3  .UshortValue) ; 
        __context__.SourceCodeLine = 379;
        TX_MATRIX  .UpdateValue ( "#audio_d out2 hdmi_source=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_SOURCE_OUTPUT4_OnChange_17 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 391;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_SOURCE_OUTPUT4  .UshortValue) ; 
        __context__.SourceCodeLine = 392;
        TX_MATRIX  .UpdateValue ( "#audio_d out3 hdmi_source=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_SOURCE_OUTPUT_ALL_OnChange_18 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 402;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_SOURCE_OUTPUT_ALL  .UshortValue) ; 
        __context__.SourceCodeLine = 403;
        TX_MATRIX  .UpdateValue ( "#audio_d out255 hdmi_source=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_EXTRACTION_SOURCE_OUTPUT1_OnChange_19 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 418;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_EXTRACTION_SOURCE_OUTPUT1  .UshortValue) ; 
        __context__.SourceCodeLine = 419;
        TX_MATRIX  .UpdateValue ( "#audio_d out0 dec_source=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_EXTRACTION_SOURCE_OUTPUT2_OnChange_20 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 431;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_EXTRACTION_SOURCE_OUTPUT2  .UshortValue) ; 
        __context__.SourceCodeLine = 432;
        TX_MATRIX  .UpdateValue ( "#audio_d out1 dec_source=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_EXTRACTION_SOURCE_OUTPUT3_OnChange_21 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 443;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_EXTRACTION_SOURCE_OUTPUT3  .UshortValue) ; 
        __context__.SourceCodeLine = 444;
        TX_MATRIX  .UpdateValue ( "#audio_d out2 dec_source=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_EXTRACTION_SOURCE_OUTPUT4_OnChange_22 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 455;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_EXTRACTION_SOURCE_OUTPUT4  .UshortValue) ; 
        __context__.SourceCodeLine = 456;
        TX_MATRIX  .UpdateValue ( "#audio_d out3 dec_source=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object AUDIO_EXTRACTION_SOURCE_OUTPUT_ALL_OnChange_23 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 466;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)AUDIO_EXTRACTION_SOURCE_OUTPUT_ALL  .UshortValue) ; 
        __context__.SourceCodeLine = 467;
        TX_MATRIX  .UpdateValue ( "#audio_d out255 dec_source=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object VIDEO_RESOLUTION_OUTPUT1_OnChange_24 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 478;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)VIDEO_RESOLUTION_OUTPUT1  .UshortValue) ; 
        __context__.SourceCodeLine = 479;
        TX_MATRIX  .UpdateValue ( "#video_d out0 resolution=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object VIDEO_RESOLUTION_OUTPUT2_OnChange_25 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 489;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)VIDEO_RESOLUTION_OUTPUT2  .UshortValue) ; 
        __context__.SourceCodeLine = 490;
        TX_MATRIX  .UpdateValue ( "#video_d out1 resolution=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object VIDEO_RESOLUTION_OUTPUT3_OnChange_26 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 501;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)VIDEO_RESOLUTION_OUTPUT3  .UshortValue) ; 
        __context__.SourceCodeLine = 502;
        TX_MATRIX  .UpdateValue ( "#video_d out2 resolution=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object VIDEO_RESOLUTION_OUTPUT4_OnChange_27 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 511;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)VIDEO_RESOLUTION_OUTPUT4  .UshortValue) ; 
        __context__.SourceCodeLine = 512;
        TX_MATRIX  .UpdateValue ( "#video_d out3 resolution=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object VIDEO_RESOLUTION_OUTPUT_ALL_OnChange_28 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 523;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)VIDEO_RESOLUTION_OUTPUT_ALL  .UshortValue) ; 
        __context__.SourceCodeLine = 524;
        TX_MATRIX  .UpdateValue ( "#video_d out255 resolution=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SEND_GAPX_OUTPUT1_OnPush_29 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 4, this );
        
        
        __context__.SourceCodeLine = 536;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)GAPX_OUTPUT1  .UshortValue) ; 
        __context__.SourceCodeLine = 537;
        TX_MATRIX  .UpdateValue ( "#video_d out0 gap_x=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SEND_GAPX_OUTPUT2_OnPush_30 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 4, this );
        
        
        __context__.SourceCodeLine = 546;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)GAPX_OUTPUT2  .UshortValue) ; 
        __context__.SourceCodeLine = 547;
        TX_MATRIX  .UpdateValue ( "#video_d out1 gap_x=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SEND_GAPX_OUTPUT3_OnPush_31 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 4, this );
        
        
        __context__.SourceCodeLine = 556;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)GAPX_OUTPUT3  .UshortValue) ; 
        __context__.SourceCodeLine = 557;
        TX_MATRIX  .UpdateValue ( "#video_d out2 gap_x=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SEND_GAPX_OUTPUT4_OnPush_32 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 4, this );
        
        
        __context__.SourceCodeLine = 566;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)GAPX_OUTPUT4  .UshortValue) ; 
        __context__.SourceCodeLine = 567;
        TX_MATRIX  .UpdateValue ( "#video_d out3 gap_x=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SEND_GAPX_OUTPUT_ALL_OnPush_33 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 4, this );
        
        
        __context__.SourceCodeLine = 576;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)GAPX_OUTPUT_ALL  .UshortValue) ; 
        __context__.SourceCodeLine = 577;
        TX_MATRIX  .UpdateValue ( "#video_d out255 gap_x=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SEND_GAPY_OUTPUT1_OnPush_34 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 4, this );
        
        
        __context__.SourceCodeLine = 586;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)GAPY_OUTPUT1  .UshortValue) ; 
        __context__.SourceCodeLine = 587;
        TX_MATRIX  .UpdateValue ( "#video_d out0 gap_y=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SEND_GAPY_OUTPUT2_OnPush_35 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 4, this );
        
        
        __context__.SourceCodeLine = 596;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)GAPY_OUTPUT2  .UshortValue) ; 
        __context__.SourceCodeLine = 597;
        TX_MATRIX  .UpdateValue ( "#video_d out1 gap_y=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SEND_GAPY_OUTPUT3_OnPush_36 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 4, this );
        
        
        __context__.SourceCodeLine = 606;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)GAPY_OUTPUT3  .UshortValue) ; 
        __context__.SourceCodeLine = 607;
        TX_MATRIX  .UpdateValue ( "#video_d out2 gap_y=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SEND_GAPY_OUTPUT4_OnPush_37 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 4, this );
        
        
        __context__.SourceCodeLine = 616;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)GAPY_OUTPUT4  .UshortValue) ; 
        __context__.SourceCodeLine = 617;
        TX_MATRIX  .UpdateValue ( "#video_d out3 gap_y=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SEND_GAPY_OUTPUT_ALL_OnPush_38 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGOUT1;
        STRINGOUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 4, this );
        
        
        __context__.SourceCodeLine = 626;
        MakeString ( STRINGOUT1 , "{0:d}", (ushort)GAPY_OUTPUT_ALL  .UshortValue) ; 
        __context__.SourceCodeLine = 627;
        TX_MATRIX  .UpdateValue ( "#video_d out255 gap_y=" + STRINGOUT1  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}


public override void LogosSplusInitialize()
{
    SocketInfo __socketinfo__ = new SocketInfo( 1, this );
    InitialParametersClass.ResolveHostName = __socketinfo__.ResolveHostName;
    _SplusNVRAM = new SplusNVRAM( this );
    
    SEND_GAPX_OUTPUT1 = new Crestron.Logos.SplusObjects.DigitalInput( SEND_GAPX_OUTPUT1__DigitalInput__, this );
    m_DigitalInputList.Add( SEND_GAPX_OUTPUT1__DigitalInput__, SEND_GAPX_OUTPUT1 );
    
    SEND_GAPX_OUTPUT2 = new Crestron.Logos.SplusObjects.DigitalInput( SEND_GAPX_OUTPUT2__DigitalInput__, this );
    m_DigitalInputList.Add( SEND_GAPX_OUTPUT2__DigitalInput__, SEND_GAPX_OUTPUT2 );
    
    SEND_GAPX_OUTPUT3 = new Crestron.Logos.SplusObjects.DigitalInput( SEND_GAPX_OUTPUT3__DigitalInput__, this );
    m_DigitalInputList.Add( SEND_GAPX_OUTPUT3__DigitalInput__, SEND_GAPX_OUTPUT3 );
    
    SEND_GAPX_OUTPUT4 = new Crestron.Logos.SplusObjects.DigitalInput( SEND_GAPX_OUTPUT4__DigitalInput__, this );
    m_DigitalInputList.Add( SEND_GAPX_OUTPUT4__DigitalInput__, SEND_GAPX_OUTPUT4 );
    
    SEND_GAPX_OUTPUT_ALL = new Crestron.Logos.SplusObjects.DigitalInput( SEND_GAPX_OUTPUT_ALL__DigitalInput__, this );
    m_DigitalInputList.Add( SEND_GAPX_OUTPUT_ALL__DigitalInput__, SEND_GAPX_OUTPUT_ALL );
    
    SEND_GAPY_OUTPUT1 = new Crestron.Logos.SplusObjects.DigitalInput( SEND_GAPY_OUTPUT1__DigitalInput__, this );
    m_DigitalInputList.Add( SEND_GAPY_OUTPUT1__DigitalInput__, SEND_GAPY_OUTPUT1 );
    
    SEND_GAPY_OUTPUT2 = new Crestron.Logos.SplusObjects.DigitalInput( SEND_GAPY_OUTPUT2__DigitalInput__, this );
    m_DigitalInputList.Add( SEND_GAPY_OUTPUT2__DigitalInput__, SEND_GAPY_OUTPUT2 );
    
    SEND_GAPY_OUTPUT3 = new Crestron.Logos.SplusObjects.DigitalInput( SEND_GAPY_OUTPUT3__DigitalInput__, this );
    m_DigitalInputList.Add( SEND_GAPY_OUTPUT3__DigitalInput__, SEND_GAPY_OUTPUT3 );
    
    SEND_GAPY_OUTPUT4 = new Crestron.Logos.SplusObjects.DigitalInput( SEND_GAPY_OUTPUT4__DigitalInput__, this );
    m_DigitalInputList.Add( SEND_GAPY_OUTPUT4__DigitalInput__, SEND_GAPY_OUTPUT4 );
    
    SEND_GAPY_OUTPUT_ALL = new Crestron.Logos.SplusObjects.DigitalInput( SEND_GAPY_OUTPUT_ALL__DigitalInput__, this );
    m_DigitalInputList.Add( SEND_GAPY_OUTPUT_ALL__DigitalInput__, SEND_GAPY_OUTPUT_ALL );
    
    CLEAR_PRESET_MODE = new Crestron.Logos.SplusObjects.AnalogInput( CLEAR_PRESET_MODE__AnalogSerialInput__, this );
    m_AnalogInputList.Add( CLEAR_PRESET_MODE__AnalogSerialInput__, CLEAR_PRESET_MODE );
    
    STORE_PRESET_MODE = new Crestron.Logos.SplusObjects.AnalogInput( STORE_PRESET_MODE__AnalogSerialInput__, this );
    m_AnalogInputList.Add( STORE_PRESET_MODE__AnalogSerialInput__, STORE_PRESET_MODE );
    
    RECALL_PRESET_MODE = new Crestron.Logos.SplusObjects.AnalogInput( RECALL_PRESET_MODE__AnalogSerialInput__, this );
    m_AnalogInputList.Add( RECALL_PRESET_MODE__AnalogSerialInput__, RECALL_PRESET_MODE );
    
    CLEAR_PRESET_SCENE = new Crestron.Logos.SplusObjects.AnalogInput( CLEAR_PRESET_SCENE__AnalogSerialInput__, this );
    m_AnalogInputList.Add( CLEAR_PRESET_SCENE__AnalogSerialInput__, CLEAR_PRESET_SCENE );
    
    STORE_PRESET_SCENE = new Crestron.Logos.SplusObjects.AnalogInput( STORE_PRESET_SCENE__AnalogSerialInput__, this );
    m_AnalogInputList.Add( STORE_PRESET_SCENE__AnalogSerialInput__, STORE_PRESET_SCENE );
    
    RECALL_PRESET_SCENE = new Crestron.Logos.SplusObjects.AnalogInput( RECALL_PRESET_SCENE__AnalogSerialInput__, this );
    m_AnalogInputList.Add( RECALL_PRESET_SCENE__AnalogSerialInput__, RECALL_PRESET_SCENE );
    
    VIDEO_FEED_ON = new Crestron.Logos.SplusObjects.AnalogInput( VIDEO_FEED_ON__AnalogSerialInput__, this );
    m_AnalogInputList.Add( VIDEO_FEED_ON__AnalogSerialInput__, VIDEO_FEED_ON );
    
    VIDEO_FEED_OFF = new Crestron.Logos.SplusObjects.AnalogInput( VIDEO_FEED_OFF__AnalogSerialInput__, this );
    m_AnalogInputList.Add( VIDEO_FEED_OFF__AnalogSerialInput__, VIDEO_FEED_OFF );
    
    AUDIO_HDMI_ON = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_HDMI_ON__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_HDMI_ON__AnalogSerialInput__, AUDIO_HDMI_ON );
    
    AUDIO_HDMI_OFF = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_HDMI_OFF__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_HDMI_OFF__AnalogSerialInput__, AUDIO_HDMI_OFF );
    
    AUDIO_SOURCE_OUTPUT1 = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_SOURCE_OUTPUT1__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_SOURCE_OUTPUT1__AnalogSerialInput__, AUDIO_SOURCE_OUTPUT1 );
    
    AUDIO_SOURCE_OUTPUT2 = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_SOURCE_OUTPUT2__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_SOURCE_OUTPUT2__AnalogSerialInput__, AUDIO_SOURCE_OUTPUT2 );
    
    AUDIO_SOURCE_OUTPUT3 = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_SOURCE_OUTPUT3__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_SOURCE_OUTPUT3__AnalogSerialInput__, AUDIO_SOURCE_OUTPUT3 );
    
    AUDIO_SOURCE_OUTPUT4 = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_SOURCE_OUTPUT4__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_SOURCE_OUTPUT4__AnalogSerialInput__, AUDIO_SOURCE_OUTPUT4 );
    
    AUDIO_SOURCE_OUTPUT_ALL = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_SOURCE_OUTPUT_ALL__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_SOURCE_OUTPUT_ALL__AnalogSerialInput__, AUDIO_SOURCE_OUTPUT_ALL );
    
    AUDIO_EXTRACTION_OFF = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_EXTRACTION_OFF__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_EXTRACTION_OFF__AnalogSerialInput__, AUDIO_EXTRACTION_OFF );
    
    AUDIO_EXTRACTION_ON = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_EXTRACTION_ON__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_EXTRACTION_ON__AnalogSerialInput__, AUDIO_EXTRACTION_ON );
    
    AUDIO_EXTRACTION_SOURCE_OUTPUT1 = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_EXTRACTION_SOURCE_OUTPUT1__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_EXTRACTION_SOURCE_OUTPUT1__AnalogSerialInput__, AUDIO_EXTRACTION_SOURCE_OUTPUT1 );
    
    AUDIO_EXTRACTION_SOURCE_OUTPUT2 = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_EXTRACTION_SOURCE_OUTPUT2__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_EXTRACTION_SOURCE_OUTPUT2__AnalogSerialInput__, AUDIO_EXTRACTION_SOURCE_OUTPUT2 );
    
    AUDIO_EXTRACTION_SOURCE_OUTPUT3 = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_EXTRACTION_SOURCE_OUTPUT3__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_EXTRACTION_SOURCE_OUTPUT3__AnalogSerialInput__, AUDIO_EXTRACTION_SOURCE_OUTPUT3 );
    
    AUDIO_EXTRACTION_SOURCE_OUTPUT4 = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_EXTRACTION_SOURCE_OUTPUT4__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_EXTRACTION_SOURCE_OUTPUT4__AnalogSerialInput__, AUDIO_EXTRACTION_SOURCE_OUTPUT4 );
    
    AUDIO_EXTRACTION_SOURCE_OUTPUT_ALL = new Crestron.Logos.SplusObjects.AnalogInput( AUDIO_EXTRACTION_SOURCE_OUTPUT_ALL__AnalogSerialInput__, this );
    m_AnalogInputList.Add( AUDIO_EXTRACTION_SOURCE_OUTPUT_ALL__AnalogSerialInput__, AUDIO_EXTRACTION_SOURCE_OUTPUT_ALL );
    
    VIDEO_RESOLUTION_OUTPUT1 = new Crestron.Logos.SplusObjects.AnalogInput( VIDEO_RESOLUTION_OUTPUT1__AnalogSerialInput__, this );
    m_AnalogInputList.Add( VIDEO_RESOLUTION_OUTPUT1__AnalogSerialInput__, VIDEO_RESOLUTION_OUTPUT1 );
    
    VIDEO_RESOLUTION_OUTPUT2 = new Crestron.Logos.SplusObjects.AnalogInput( VIDEO_RESOLUTION_OUTPUT2__AnalogSerialInput__, this );
    m_AnalogInputList.Add( VIDEO_RESOLUTION_OUTPUT2__AnalogSerialInput__, VIDEO_RESOLUTION_OUTPUT2 );
    
    VIDEO_RESOLUTION_OUTPUT3 = new Crestron.Logos.SplusObjects.AnalogInput( VIDEO_RESOLUTION_OUTPUT3__AnalogSerialInput__, this );
    m_AnalogInputList.Add( VIDEO_RESOLUTION_OUTPUT3__AnalogSerialInput__, VIDEO_RESOLUTION_OUTPUT3 );
    
    VIDEO_RESOLUTION_OUTPUT4 = new Crestron.Logos.SplusObjects.AnalogInput( VIDEO_RESOLUTION_OUTPUT4__AnalogSerialInput__, this );
    m_AnalogInputList.Add( VIDEO_RESOLUTION_OUTPUT4__AnalogSerialInput__, VIDEO_RESOLUTION_OUTPUT4 );
    
    VIDEO_RESOLUTION_OUTPUT_ALL = new Crestron.Logos.SplusObjects.AnalogInput( VIDEO_RESOLUTION_OUTPUT_ALL__AnalogSerialInput__, this );
    m_AnalogInputList.Add( VIDEO_RESOLUTION_OUTPUT_ALL__AnalogSerialInput__, VIDEO_RESOLUTION_OUTPUT_ALL );
    
    GAPX_OUTPUT1 = new Crestron.Logos.SplusObjects.AnalogInput( GAPX_OUTPUT1__AnalogSerialInput__, this );
    m_AnalogInputList.Add( GAPX_OUTPUT1__AnalogSerialInput__, GAPX_OUTPUT1 );
    
    GAPX_OUTPUT2 = new Crestron.Logos.SplusObjects.AnalogInput( GAPX_OUTPUT2__AnalogSerialInput__, this );
    m_AnalogInputList.Add( GAPX_OUTPUT2__AnalogSerialInput__, GAPX_OUTPUT2 );
    
    GAPX_OUTPUT3 = new Crestron.Logos.SplusObjects.AnalogInput( GAPX_OUTPUT3__AnalogSerialInput__, this );
    m_AnalogInputList.Add( GAPX_OUTPUT3__AnalogSerialInput__, GAPX_OUTPUT3 );
    
    GAPX_OUTPUT4 = new Crestron.Logos.SplusObjects.AnalogInput( GAPX_OUTPUT4__AnalogSerialInput__, this );
    m_AnalogInputList.Add( GAPX_OUTPUT4__AnalogSerialInput__, GAPX_OUTPUT4 );
    
    GAPX_OUTPUT_ALL = new Crestron.Logos.SplusObjects.AnalogInput( GAPX_OUTPUT_ALL__AnalogSerialInput__, this );
    m_AnalogInputList.Add( GAPX_OUTPUT_ALL__AnalogSerialInput__, GAPX_OUTPUT_ALL );
    
    GAPY_OUTPUT1 = new Crestron.Logos.SplusObjects.AnalogInput( GAPY_OUTPUT1__AnalogSerialInput__, this );
    m_AnalogInputList.Add( GAPY_OUTPUT1__AnalogSerialInput__, GAPY_OUTPUT1 );
    
    GAPY_OUTPUT2 = new Crestron.Logos.SplusObjects.AnalogInput( GAPY_OUTPUT2__AnalogSerialInput__, this );
    m_AnalogInputList.Add( GAPY_OUTPUT2__AnalogSerialInput__, GAPY_OUTPUT2 );
    
    GAPY_OUTPUT3 = new Crestron.Logos.SplusObjects.AnalogInput( GAPY_OUTPUT3__AnalogSerialInput__, this );
    m_AnalogInputList.Add( GAPY_OUTPUT3__AnalogSerialInput__, GAPY_OUTPUT3 );
    
    GAPY_OUTPUT4 = new Crestron.Logos.SplusObjects.AnalogInput( GAPY_OUTPUT4__AnalogSerialInput__, this );
    m_AnalogInputList.Add( GAPY_OUTPUT4__AnalogSerialInput__, GAPY_OUTPUT4 );
    
    GAPY_OUTPUT_ALL = new Crestron.Logos.SplusObjects.AnalogInput( GAPY_OUTPUT_ALL__AnalogSerialInput__, this );
    m_AnalogInputList.Add( GAPY_OUTPUT_ALL__AnalogSerialInput__, GAPY_OUTPUT_ALL );
    
    OUTPUT = new InOutArray<AnalogInput>( 4, this );
    for( uint i = 0; i < 4; i++ )
    {
        OUTPUT[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( OUTPUT__AnalogSerialInput__ + i, OUTPUT__AnalogSerialInput__, this );
        m_AnalogInputList.Add( OUTPUT__AnalogSerialInput__ + i, OUTPUT[i+1] );
    }
    
    TX_MATRIX = new Crestron.Logos.SplusObjects.StringOutput( TX_MATRIX__AnalogSerialOutput__, this );
    m_StringOutputList.Add( TX_MATRIX__AnalogSerialOutput__, TX_MATRIX );
    
    TO_SIO = new Crestron.Logos.SplusObjects.StringOutput( TO_SIO__AnalogSerialOutput__, this );
    m_StringOutputList.Add( TO_SIO__AnalogSerialOutput__, TO_SIO );
    
    RX_MATRIX = new Crestron.Logos.SplusObjects.BufferInput( RX_MATRIX__AnalogSerialInput__, 255, this );
    m_StringInputList.Add( RX_MATRIX__AnalogSerialInput__, RX_MATRIX );
    
    
    RX_MATRIX.OnSerialChange.Add( new InputChangeHandlerWrapper( RX_MATRIX_OnChange_0, false ) );
    CLEAR_PRESET_MODE.OnAnalogChange.Add( new InputChangeHandlerWrapper( CLEAR_PRESET_MODE_OnChange_1, false ) );
    STORE_PRESET_MODE.OnAnalogChange.Add( new InputChangeHandlerWrapper( STORE_PRESET_MODE_OnChange_2, false ) );
    RECALL_PRESET_MODE.OnAnalogChange.Add( new InputChangeHandlerWrapper( RECALL_PRESET_MODE_OnChange_3, false ) );
    CLEAR_PRESET_SCENE.OnAnalogChange.Add( new InputChangeHandlerWrapper( CLEAR_PRESET_SCENE_OnChange_4, false ) );
    STORE_PRESET_SCENE.OnAnalogChange.Add( new InputChangeHandlerWrapper( STORE_PRESET_SCENE_OnChange_5, false ) );
    RECALL_PRESET_SCENE.OnAnalogChange.Add( new InputChangeHandlerWrapper( RECALL_PRESET_SCENE_OnChange_6, false ) );
    VIDEO_FEED_OFF.OnAnalogChange.Add( new InputChangeHandlerWrapper( VIDEO_FEED_OFF_OnChange_7, false ) );
    VIDEO_FEED_ON.OnAnalogChange.Add( new InputChangeHandlerWrapper( VIDEO_FEED_ON_OnChange_8, false ) );
    AUDIO_HDMI_OFF.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_HDMI_OFF_OnChange_9, false ) );
    AUDIO_HDMI_ON.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_HDMI_ON_OnChange_10, false ) );
    AUDIO_EXTRACTION_OFF.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_EXTRACTION_OFF_OnChange_11, false ) );
    AUDIO_EXTRACTION_ON.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_EXTRACTION_ON_OnChange_12, false ) );
    for( uint i = 0; i < 4; i++ )
        OUTPUT[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( OUTPUT_OnChange_13, false ) );
        
    AUDIO_SOURCE_OUTPUT1.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_SOURCE_OUTPUT1_OnChange_14, false ) );
    AUDIO_SOURCE_OUTPUT2.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_SOURCE_OUTPUT2_OnChange_15, false ) );
    AUDIO_SOURCE_OUTPUT3.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_SOURCE_OUTPUT3_OnChange_16, false ) );
    AUDIO_SOURCE_OUTPUT4.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_SOURCE_OUTPUT4_OnChange_17, false ) );
    AUDIO_SOURCE_OUTPUT_ALL.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_SOURCE_OUTPUT_ALL_OnChange_18, false ) );
    AUDIO_EXTRACTION_SOURCE_OUTPUT1.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_EXTRACTION_SOURCE_OUTPUT1_OnChange_19, false ) );
    AUDIO_EXTRACTION_SOURCE_OUTPUT2.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_EXTRACTION_SOURCE_OUTPUT2_OnChange_20, false ) );
    AUDIO_EXTRACTION_SOURCE_OUTPUT3.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_EXTRACTION_SOURCE_OUTPUT3_OnChange_21, false ) );
    AUDIO_EXTRACTION_SOURCE_OUTPUT4.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_EXTRACTION_SOURCE_OUTPUT4_OnChange_22, false ) );
    AUDIO_EXTRACTION_SOURCE_OUTPUT_ALL.OnAnalogChange.Add( new InputChangeHandlerWrapper( AUDIO_EXTRACTION_SOURCE_OUTPUT_ALL_OnChange_23, false ) );
    VIDEO_RESOLUTION_OUTPUT1.OnAnalogChange.Add( new InputChangeHandlerWrapper( VIDEO_RESOLUTION_OUTPUT1_OnChange_24, false ) );
    VIDEO_RESOLUTION_OUTPUT2.OnAnalogChange.Add( new InputChangeHandlerWrapper( VIDEO_RESOLUTION_OUTPUT2_OnChange_25, false ) );
    VIDEO_RESOLUTION_OUTPUT3.OnAnalogChange.Add( new InputChangeHandlerWrapper( VIDEO_RESOLUTION_OUTPUT3_OnChange_26, false ) );
    VIDEO_RESOLUTION_OUTPUT4.OnAnalogChange.Add( new InputChangeHandlerWrapper( VIDEO_RESOLUTION_OUTPUT4_OnChange_27, false ) );
    VIDEO_RESOLUTION_OUTPUT_ALL.OnAnalogChange.Add( new InputChangeHandlerWrapper( VIDEO_RESOLUTION_OUTPUT_ALL_OnChange_28, false ) );
    SEND_GAPX_OUTPUT1.OnDigitalPush.Add( new InputChangeHandlerWrapper( SEND_GAPX_OUTPUT1_OnPush_29, false ) );
    SEND_GAPX_OUTPUT2.OnDigitalPush.Add( new InputChangeHandlerWrapper( SEND_GAPX_OUTPUT2_OnPush_30, false ) );
    SEND_GAPX_OUTPUT3.OnDigitalPush.Add( new InputChangeHandlerWrapper( SEND_GAPX_OUTPUT3_OnPush_31, false ) );
    SEND_GAPX_OUTPUT4.OnDigitalPush.Add( new InputChangeHandlerWrapper( SEND_GAPX_OUTPUT4_OnPush_32, false ) );
    SEND_GAPX_OUTPUT_ALL.OnDigitalPush.Add( new InputChangeHandlerWrapper( SEND_GAPX_OUTPUT_ALL_OnPush_33, false ) );
    SEND_GAPY_OUTPUT1.OnDigitalPush.Add( new InputChangeHandlerWrapper( SEND_GAPY_OUTPUT1_OnPush_34, false ) );
    SEND_GAPY_OUTPUT2.OnDigitalPush.Add( new InputChangeHandlerWrapper( SEND_GAPY_OUTPUT2_OnPush_35, false ) );
    SEND_GAPY_OUTPUT3.OnDigitalPush.Add( new InputChangeHandlerWrapper( SEND_GAPY_OUTPUT3_OnPush_36, false ) );
    SEND_GAPY_OUTPUT4.OnDigitalPush.Add( new InputChangeHandlerWrapper( SEND_GAPY_OUTPUT4_OnPush_37, false ) );
    SEND_GAPY_OUTPUT_ALL.OnDigitalPush.Add( new InputChangeHandlerWrapper( SEND_GAPY_OUTPUT_ALL_OnPush_38, false ) );
    
    _SplusNVRAM.PopulateCustomAttributeList( true );
    
    NVRAM = _SplusNVRAM;
    
}

public override void LogosSimplSharpInitialize()
{
    
    
}

public UserModuleClass_BG_4K_VP44 ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}




const uint RX_MATRIX__AnalogSerialInput__ = 0;
const uint CLEAR_PRESET_MODE__AnalogSerialInput__ = 1;
const uint STORE_PRESET_MODE__AnalogSerialInput__ = 2;
const uint RECALL_PRESET_MODE__AnalogSerialInput__ = 3;
const uint CLEAR_PRESET_SCENE__AnalogSerialInput__ = 4;
const uint STORE_PRESET_SCENE__AnalogSerialInput__ = 5;
const uint RECALL_PRESET_SCENE__AnalogSerialInput__ = 6;
const uint VIDEO_FEED_ON__AnalogSerialInput__ = 7;
const uint VIDEO_FEED_OFF__AnalogSerialInput__ = 8;
const uint AUDIO_HDMI_ON__AnalogSerialInput__ = 9;
const uint AUDIO_HDMI_OFF__AnalogSerialInput__ = 10;
const uint AUDIO_SOURCE_OUTPUT1__AnalogSerialInput__ = 11;
const uint AUDIO_SOURCE_OUTPUT2__AnalogSerialInput__ = 12;
const uint AUDIO_SOURCE_OUTPUT3__AnalogSerialInput__ = 13;
const uint AUDIO_SOURCE_OUTPUT4__AnalogSerialInput__ = 14;
const uint AUDIO_SOURCE_OUTPUT_ALL__AnalogSerialInput__ = 15;
const uint AUDIO_EXTRACTION_OFF__AnalogSerialInput__ = 16;
const uint AUDIO_EXTRACTION_ON__AnalogSerialInput__ = 17;
const uint AUDIO_EXTRACTION_SOURCE_OUTPUT1__AnalogSerialInput__ = 18;
const uint AUDIO_EXTRACTION_SOURCE_OUTPUT2__AnalogSerialInput__ = 19;
const uint AUDIO_EXTRACTION_SOURCE_OUTPUT3__AnalogSerialInput__ = 20;
const uint AUDIO_EXTRACTION_SOURCE_OUTPUT4__AnalogSerialInput__ = 21;
const uint AUDIO_EXTRACTION_SOURCE_OUTPUT_ALL__AnalogSerialInput__ = 22;
const uint VIDEO_RESOLUTION_OUTPUT1__AnalogSerialInput__ = 23;
const uint VIDEO_RESOLUTION_OUTPUT2__AnalogSerialInput__ = 24;
const uint VIDEO_RESOLUTION_OUTPUT3__AnalogSerialInput__ = 25;
const uint VIDEO_RESOLUTION_OUTPUT4__AnalogSerialInput__ = 26;
const uint VIDEO_RESOLUTION_OUTPUT_ALL__AnalogSerialInput__ = 27;
const uint SEND_GAPX_OUTPUT1__DigitalInput__ = 0;
const uint SEND_GAPX_OUTPUT2__DigitalInput__ = 1;
const uint SEND_GAPX_OUTPUT3__DigitalInput__ = 2;
const uint SEND_GAPX_OUTPUT4__DigitalInput__ = 3;
const uint SEND_GAPX_OUTPUT_ALL__DigitalInput__ = 4;
const uint SEND_GAPY_OUTPUT1__DigitalInput__ = 5;
const uint SEND_GAPY_OUTPUT2__DigitalInput__ = 6;
const uint SEND_GAPY_OUTPUT3__DigitalInput__ = 7;
const uint SEND_GAPY_OUTPUT4__DigitalInput__ = 8;
const uint SEND_GAPY_OUTPUT_ALL__DigitalInput__ = 9;
const uint GAPX_OUTPUT1__AnalogSerialInput__ = 28;
const uint GAPX_OUTPUT2__AnalogSerialInput__ = 29;
const uint GAPX_OUTPUT3__AnalogSerialInput__ = 30;
const uint GAPX_OUTPUT4__AnalogSerialInput__ = 31;
const uint GAPX_OUTPUT_ALL__AnalogSerialInput__ = 32;
const uint GAPY_OUTPUT1__AnalogSerialInput__ = 33;
const uint GAPY_OUTPUT2__AnalogSerialInput__ = 34;
const uint GAPY_OUTPUT3__AnalogSerialInput__ = 35;
const uint GAPY_OUTPUT4__AnalogSerialInput__ = 36;
const uint GAPY_OUTPUT_ALL__AnalogSerialInput__ = 37;
const uint OUTPUT__AnalogSerialInput__ = 38;
const uint TX_MATRIX__AnalogSerialOutput__ = 0;
const uint TO_SIO__AnalogSerialOutput__ = 1;

[SplusStructAttribute(-1, true, false)]
public class SplusNVRAM : SplusStructureBase
{

    public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
    
    
}

SplusNVRAM _SplusNVRAM = null;

public class __CEvent__ : CEvent
{
    public __CEvent__() {}
    public void Close() { base.Close(); }
    public int Reset() { return base.Reset() ? 1 : 0; }
    public int Set() { return base.Set() ? 1 : 0; }
    public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
}
public class __CMutex__ : CMutex
{
    public __CMutex__() {}
    public void Close() { base.Close(); }
    public void ReleaseMutex() { base.ReleaseMutex(); }
    public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
}
 public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}


}
